#! /bin/bash

######################################################################################################################
#                                                                                                                    #
#                                              Mirror downloads utilities                                            #
#                                                                                                                    #
######################################################################################################################

# Global source mirrors
: ${YOCTOPROJECT_MIRROR_URL:="http://downloads.yoctoproject.org/mirror/sources/"}
: ${AC6_MIRROR_URL:="http://downloads.ac6-tools.com/mirror/sources/"}

# Specialized mirrors (searched last)
: ${APACHE_MIRROR:="http://archive.apache.org/dist"}
: ${DEBIAN_MIRROR:="http://ftp.debian.org/debian/pool"}
: ${GENTOO_MIRROR:="http://distfiles.gentoo.org/distfiles"}
: ${GNOME_GIT:="git://git.gnome.org"}
: ${GNOME_MIRROR:="http://ftp.gnome.org/pub/GNOME/sources"}
: ${GNU_MIRROR:="https://ftp.gnu.org/gnu"}
: ${GNUPG_MIRROR:="http://www.gnupg.org/ftp/gcrypt"}
: ${GPE_MIRROR:="http://gpe.linuxtogo.org/download/source"}
: ${KERNELORG_MIRROR:="http://cdn.kernel.org/pub"}
: ${SOURCEFORGE_MIRROR:="http://downloads.sourceforge.net"}
: ${XLIBS_MIRROR:="http://xlibs.freedesktop.org/release"}
: ${XORG_MIRROR:="http://xorg.freedesktop.org/releases"}
: ${SAVANNAH_GNU_MIRROR:="http://download.savannah.gnu.org/releases"}
: ${SAVANNAH_NONGNU_MIRROR:="http://download.savannah.nongnu.org/releases"}
: ${CPAN_MIRROR:="http://search.cpan.org/CPAN"}

MIRRORS="$MIRRORS ; \
${DEBIAN_MIRROR}	http://snapshot.debian.org/archive/debian-archive/20120328T092752Z/debian/pool ; \
${DEBIAN_MIRROR}	http://snapshot.debian.org/archive/debian-archive/20110127T084257Z/debian/pool ; \
${DEBIAN_MIRROR}	http://snapshot.debian.org/archive/debian-archive/20090802T004153Z/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.de.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.au.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.cl.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.hr.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.fi.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.hk.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.hu.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.ie.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.it.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.jp.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.no.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.pl.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.ro.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.si.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.es.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.se.debian.org/debian/pool ; \
${DEBIAN_MIRROR}	http://ftp.tr.debian.org/debian/pool ; \
${GNU_MIRROR}	https://mirrors.kernel.org/gnu ; \
${KERNELORG_MIRROR}	http://www.kernel.org/pub ; \
${GNUPG_MIRROR}	ftp://ftp.gnupg.org/gcrypt ; \
${GNUPG_MIRROR}	ftp://ftp.franken.de/pub/crypt/mirror/ftp.gnupg.org/gcrypt ; \
${GNUPG_MIRROR}	ftp://mirrors.dotsrc.org/gcrypt ; \
ftp://dante.ctan.org/tex-archive ftp://ftp.fu-berlin.de/tex/CTAN ; \
ftp://dante.ctan.org/tex-archive http://sunsite.sut.ac.jp/pub/archives/ctan/ ; \
ftp://dante.ctan.org/tex-archive http://ctan.unsw.edu.au/ ; \
ftp://ftp.gnutls.org/gcrypt/gnutls ${GNUPG_MIRROR}/gnutls ; \
http://ftp.info-zip.org/pub/infozip/src/ http://mirror.switch.ch/ftp/mirror/infozip/src/ ; \
http://ftp.info-zip.org/pub/infozip/src/ ftp://sunsite.icm.edu.pl/pub/unix/archiving/info-zip/src/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://ftp.cerias.purdue.edu/pub/tools/unix/sysutils/lsof/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://ftp.tau.ac.il/pub/unix/admin/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://ftp.cert.dfn.de/pub/tools/admin/lsof/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://ftp.fu-berlin.de/pub/unix/tools/lsof/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://ftp.kaizo.org/pub/lsof/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://ftp.tu-darmstadt.de/pub/sysadmin/lsof/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://ftp.tux.org/pub/sites/vic.cc.purdue.edu/tools/unix/lsof/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://gd.tuwien.ac.at/utils/admin-tools/lsof/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://sunsite.ualberta.ca/pub/Mirror/lsof/ ; \
ftp://lsof.itap.purdue.edu/pub/tools/unix/lsof/  ftp://the.wiretapped.net/pub/security/host-security/lsof/ ; \
${APACHE_MIRROR}  http://www.us.apache.org/dist ; \
${APACHE_MIRROR}  http://archive.apache.org/dist ; \
http://downloads.sourceforge.net/watchdog/ http://fossies.org/linux/misc/ ; \
${SAVANNAH_GNU_MIRROR} http://download-mirror.savannah.gnu.org/releases ; \
${SAVANNAH_NONGNU_MIRROR} http://download-mirror.savannah.nongnu.org/releases ; \
${CPAN_MIRROR}  http://cpan.metacpan.org/ ; \
${CPAN_MIRROR}  http://search.cpan.org/CPAN/"

if [ -n "$ADDITIONAL_MIRRORS" ]; then
	ALL_MIRRORS="MIRRORS ; $ADDITIONAL_MIRRORS"
else
	ALL_MIRRORS="$MIRRORS"
fi

# Last chance mirrors can be provided in ${default_mirrors}

#
# Get the sources URLs from internal mirrors
# 	srcUrl original source URL
#
get_mirror_urls() {
	local srcFile="$1"
	local srcUrl="$2"
	local match="${3:-false}"
	local srcFilename="${srcFile##*/}"
	local uriFilename="${srcUrl##*/}"
	local uriBase="${srcUrl%/*}"
	local line mirror origUri newUri file files

	if [ -z "$srcFilename" -a -z "$uriFilename" ]; then
		warning "Can't get directory '$srcUrl' from a mirror, only plain files can be mirorred" 
		return
	fi
	if [ -z "$srcFilename" ]; then
		srcFilename="$uriFilename"
	fi
	
	origUri="${srcUrl#*://}"
	origUri="${origUri#*/}"
	local twonames
	if [ "${origUri}" != "${srcFilename}" ]; then 
		twonames=true
	else
		twonames=false
	fi
	
	declare -a filenames
	
	if $twonames; then 
		filenames+=( "$origUri" "$srcFilename" )
	else
		filenames+=( "$origUri" )
	fi
	if $match; then
		# Lookup first .tar.gz, as this is the default for yocto, then
		# lzo which is SW4L choice as it is faster and quite efficient
		local ext
		for ext in tar.gz tgz \
		           tar.lzo tzo \
		           tar.xz txz tar.lzma tlz \
		           tar.bz2 tbz2 tar.bz tbz \
		           tar
		do
			if [ "${srcFilename%.tar*}.$ext" != "${srcFilename}" ]; then 
				if $twonames; then 
					filenames+=( "${origUri%.tar*}.$ext" "${srcFilename%.tar*}.$ext" )
				else
					filenames+=( "${origUri%.tar*}.$ext" )
				fi
			fi
		done
	fi
	
	declare -a listMirrors
	
	for mirror in ${USER_MIRROR_URL} ${YOCTOPROJECT_MIRROR_URL} ${AC6_MIRROR_URL}; do
		for file in "${filenames[@]}"; do
			newUri="${mirror%/}/${file}"
			if ! [[ " ${listMirrors[*]} " =~ " $newUri " ]]; then
				listMirrors+=( "${newUri}" )
			fi
		done
	done
	
	# MIRRORS is a semicolon separated list of pairs "origUri" "mirrorUri"
	IFS=';' read -rd '' -a mirrors <<< "$ALL_MIRRORS"
	for line in "${mirrors[@]}"; do
    	mirror=($line)
    	origUri=${mirror[0]}
    	newUri=${mirror[1]}
    	if [ -z "$origUri" -o -z "$newUri" ]; then continue; fi
		if [[ $srcUrl =~ ^${origUri}.* ]]; then
			mirror="${srcUrl//$origUri/$newUri}"
			if ! [[ " ${listMirrors[*]} " =~ " $mirror " ]]; then
				listMirrors+=( "${mirror}" )
			fi
		fi
	done
	
	# Last chance mirrors
	for mirror in $default_mirrors; do
		for file in "${filenames[@]}"; do
			newUri="${mirror%/}/${file}"
			if ! [[ " ${listMirrors[*]} " =~ " $newUri " ]]; then
				listMirrors+=( "${newUri}" )
			fi
		done
	done
	echo ${listMirrors[*]}
}

#
# Fetch a file from one of the defined mirrors
#
wget_from_mirror() {
	local srcFile="$1"
	local destDir="$(dirname $srcFile)"
	local srcUrl="$2"
	local match="${3:-false}"
	local quiet="${4:-false}"
	local silent="${5:-false}"
	local listMirrorUrls=$(get_mirror_urls "$srcFile" "$srcUrl" $match)
	local mirrorUrl altUrl gotFile
	
	if $silent; then quiet=true; fi
	for mirrorUrl in $listMirrorUrls ; do
		$quiet || log "Check mirror URL: '$mirrorUrl'"
		if wget_check "$mirrorUrl" ; then
			$silent || message "Trying to get from mirror URL: '$mirrorUrl'"
			# If match is true, we may unexpectedly have got a file with a different name
			if $match; then
				gotFile="$destDir/${mirrorUrl##*/}"
			else
				gotFile="$srcFile"
			fi
			if wget_download "$gotFile" "$mirrorUrl"; then
				if $match; then echo "$gotFile"; fi
				return 0
			fi
			$quiet || warning "Mirror URL '$mirrorUrl' don't work; looking for another mirror"
		fi
	done
	$quiet || error "No mirror provides '$srcUrl'"
	return 1
}
