######################################################################################################################
#                                                                                                                    #
#                                          		DOS Partition utilities                                              #
#                                                                                                                    #
######################################################################################################################

##################################################
# Add DOS partition definition into sfdisk dump file
# 	dumpFile	sfdisk dump file to define disk image
# 	partName	Partition name
# 	partType	Partition type (binary, system, filesystem, shadow)
# 	partStart	Start sector
# 	partSize	Partition size in sectors count	
# 	extraOpts	Extra options		
##################################################
dos_sfdisk_add_partition() {
	local dumpFile="${1}"
	local partName="${2}"
	local partType="${3}"
	local partStart="${4}"
	local partSize="${5}"
	local extraOpts="${6}"
	
	case ${partType} in
		binary)
			echo -e "start=\t${partStart}, size=\t${partSize}, type=00, name=\"${partName}\"${extraOpts}" >> ${dumpFile}
			;;
		system)
			echo -e "start=\t${partStart}, size=\t${partSize}, type=0c, name=\"${partName}\"${extraOpts}" >> ${dumpFile}
			;;
		filesystem)
			echo -e "start=\t${partStart}, size=\t${partSize}, type=83, name=\"${partName}\"${extraOpts}" >> ${dumpFile}
			;;
		shadow)
			# Shadow Partition that are not in the partition table
			;;
		*)
			fatal 1 "DOS Partition ${partName}: Type ${partType} is not supported"
			;;
	esac
}